package com.ibm.oti.shared;

import java.util.HashMap;

/*
 * Licensed Materials - Property of IBM,
 *     Copyright IBM Corp. 1998, 2010  All Rights Reserved
 */

/**
 * Implementation of SharedDataHelperFactory.
 * <p>
 * @author		OTI
 * @version		initial
 *
 * @see SharedClassHelperFactory
 * @see SharedAbstractHelperFactory
 */
public class SharedDataHelperFactoryImpl extends SharedAbstractHelperFactory implements SharedDataHelperFactory {

	static HashMap helpers;

	static {
		helpers = new HashMap();
	}

	public SharedDataHelper getDataHelper(ClassLoader owner) {
		if (owner==null) {
			return null;
		}
		synchronized(helpers) {
			SharedHelper helper = findSharedHelperForClassLoader(owner);

			if (helper!=null) {
				if (helper instanceof SharedDataHelper) {
					return (SharedDataHelper)helper;
				}
			} else {
				boolean canFind = canFind(owner);
				boolean canStore = canStore(owner);

				if (canFind || canStore) {
					SharedDataHelper result = new SharedDataHelperImpl(owner, getNewID(), canFind, canStore);
					addHelper(owner, result);
					return result;
				}
			}
		}
		return null;
	}

	HashMap getHelperMap() {
		return helpers;
	}
}
